
Smart Proxy - Bug #2412

Smartproxy TFTP using wget -c to pull new PXE defaults produces errors while booting

04/18/2013 03:24 PM - Daniel Nägele
Triaged: Yes Found in Releases:  
Description

All Smartproxies use the following command to pull the new images from the Foreman server:

cmd = "wget --timeout=10 --tries=3 --no-check-certificate -nv -c #{src} -O \"#{destination}\""

The wget manpage about the -c switch:

 -c

  --continue

     Continue getting a partially-downloaded file.  This is useful when you want to finish up a do

wnload started by a previous instance of Wget, or by another program.

Two of our Smartproxies ended up with larger images in their /srv/tftp, because wget appended the new images for some reason.

This led to some strange behaviour on new hosts booting for the first time, like kernel panics while booting or running in a bootloop.

The removal of the -c-flag in the source code of all affected Smartproxies fixed those.    

A diff of the code we are using now:

danieln@some-smartproxy:~$ diff /usr/share/foreman-proxy/lib/proxy/tftp.rb /usr/share/foreman-prox

y/lib/proxy/tftp_fixed.rb 

95c95

<       cmd = "wget --timeout=10 --tries=3 --no-check-certificate -nv -c #{src} -O \"#{destination

}\"" 

---

>       cmd = "wget --timeout=10 --tries=3 --no-check-certificate -nv #{src} -O \"#{destination}\"

" 

Related issues:

Related to Foreman - Bug #33328: Files in tftpboot/boot don't pick up changed... Duplicate

Associated revisions

Revision b94c9b07 - 09/01/2021 11:11 AM - Lukas Zapletal 

Fixes #2412 - don't continue wget downloads

Revision 3d87c6fe - 11/09/2021 01:48 PM - Lukas Zapletal 

Refs #2412 - use curl for downloads

05/17/2024 1/3



History

#1 - 07/12/2018 06:40 AM - Ohad Levy

- Description updated

- Assignee deleted (Ohad Levy)

- Triaged set to No

this is actually activity discussed at https://community.theforeman.org/t/rfc-drop-c-flag-from-wget-on-tftp-proxy/10010

#2 - 07/12/2018 02:26 PM - Lukas Zapletal

I can confirm your workaround is only reasonable one for now, I want to redesign how we download PXE files, hopefully next month.

#3 - 02/09/2021 01:09 PM - Lukas Zapletal

- Project changed from Foreman to Smart Proxy

- Category changed from TFTP to TFTP

- Assignee set to Lukas Zapletal

- Priority changed from Normal to High

- Difficulty set to easy

- Triaged changed from No to Yes

With CentOS 8 Stream this is a more painful issue, I was planning rewriting this code but there is no time - let's change -c to --timestamping

--no-if-modified-since.

#4 - 02/09/2021 02:05 PM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/smart-proxy/pull/785 added

#5 - 08/26/2021 11:15 AM - Lukas Zapletal

- Related to Bug #33328: Files in tftpboot/boot don't pick up changed files added

#6 - 09/01/2021 11:11 AM - The Foreman Bot

- Fixed in Releases 3.1.0 added

#7 - 09/01/2021 11:38 AM - The Foreman Bot

- Pull request https://github.com/theforeman/smart-proxy/pull/798 added

#8 - 09/01/2021 11:39 AM - Lukas Zapletal

- Target version set to 3.0.0

Requesting 3.0, multiple users hitting this due to CentOS Stream

#9 - 09/01/2021 12:08 PM - Anonymous

- Status changed from Ready For Testing to Closed

Applied in changeset b94c9b07a78fc8c4eb382eb574b28eed48001d25.

#10 - 09/02/2021 08:32 AM - The Foreman Bot

- Pull request https://github.com/theforeman/smart-proxy/pull/799 added

#11 - 09/20/2021 10:54 AM - Ewoud Kohl van Wijngaarden

- Target version changed from 3.0.0 to 3.0.1

3.0.0 has been released already, moving the target version.

#12 - 10/13/2021 12:19 PM - Ewoud Kohl van Wijngaarden

- Target version deleted (3.0.1)
Since this introduced a regression, I'm removing it from 3.0.1.
